# stl_iterator_base_types.h File Reference

## Detailed Description

This is an internal header file, included by other library headers. You should not attempt to use it directly.

This file contains all of the general iterator-related utility types, such as iterator_traits and struct iterator.

Definition in file stl_iterator_base_types.h.

Go to the source code of this file.

## Namespaces

- namespace std

## Classes

- struct std::bidirectional_iterator_tag
    operations. More...
- struct std::forward_iterator_tag
    Forward iterators support a superset of input iterator operations. More...
- struct std::input_iterator_tag
    Marking input iterators. More...
- struct std::iterator< _Category, _Tp, _Distance, _Pointer, _Reference >
    Common iterator class. More...
- struct std::iterator_traits< _Iterator >
- struct std::iterator_traits< _Tp * >
- struct std::iterator_traits< const _Tp * >
- struct std::output_iterator_tag
    Marking output iterators. More...
- struct std::random_access_iterator_tag
    operations. More...

## Defines

- #define _ITERATOR_BASE_TYPES_H

## Functions

- template<typename _Iter> iterator_traits< _Iter
  >::iterator_category std::__iterator_category (const _Iter &)